unit Unleash;

interface

uses
  SysUtils, WinTypes, WinProcs,
  Messages, Classes, Graphics,
  Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TSmallEdit = class(TEdit)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TBigEdit = class(TSmallEdit)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TSmallLabel = class(TLabel)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TBigLabel = class(TSmallLabel)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TEmptyPanel = class(TPanel)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TRadio2Panel = class(TEmptyPanel)
  private
    FRadio1: TRadiobutton;
    FRadio2: TRadioButton;
  public
    constructor Create(AOwner: TComponent); override;
    property Radio1: TRadioButton read FRadio1;
    property Radio2: TRadioButton read FRadio2;
  end;


procedure Register;

implementation

constructor TSmallEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Color := clBlue;
  Font.Color := clYellow;
  Font.Name := 'New Times Roman';
  Font.Size := 12;
  Font.Style := [fsBold];
end;

constructor TBigEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Font.Size := 24;
end;

constructor TSmallLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Color := clBlue;
  Font.Color := clYellow;
  Font.Name := 'New Times Roman';
  Font.Size := 12;
  Font.Style := [fsBold];
end;

constructor TBigLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Font.Size := 24;
end;

constructor TEmptyPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Caption := ' ';
end;

constructor TRadio2Panel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := 175;
  Height := 60;

  FRadio1 := TRadioButton.Create(AOwner);
  FRadio1.Parent := Self;
  FRadio1.Caption := 'Radio1';
  FRadio1.Left := 20;
  FRadio1.Top := 10;
  FRadio1.Show;

  FRadio2 := TRadioButton.Create(AOwner);
  FRadio2.Parent := Self;
  FRadio2.Caption := 'Radio2';
  FRadio2.Left := 20;
  FRadio2.Top := 32;
  FRadio2.Show;
end;

procedure Register;
begin
  RegisterComponents('Unleash', [TSmallEdit, TBigEdit,
                               TSmallLabel, TBigLabel,
                               TEmptyPanel, TRadio2Panel]);
end;


end.
